/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* Ce logiciel est du domaine public. Vous avez la permission   *
* d'utiliser, de copier et de modifier ce logiciel.            *
****************************************************************
* Ne me contactez pas SVP pour des informations, bugs,         *
* commentaires, problemes, contributions, offres d'emploi.     *
* Si vous aimez ce logiciel, envoyez une carte postale a       *
* l'adresse suivante :                                         *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA (Moldavie)                                           *
****************************************************************
* L'auteur n'est pas responsable pour les dommages occasionnes *
* par l'utilisation de ce logiciel ou de ses derives.          *
\**************************************************************/

import java.awt.*;

public class VasOnglets extends Panel {
//security
  //how much tabs can be enabled
  int maxAuthorized=4;
//end_security
  //police utilisee et sa cousine "grasse" :-)
  Font policeOnglet=new Font("Helvetica", Font.PLAIN, 12);
  Font policeGOnglet=new Font("Helvetica", Font.BOLD, 12);
  //caracteristiques de celle "grasse"
  FontMetrics carPoliceG=getFontMetrics(policeGOnglet);
 
  //couleurs utilisees
  Color couleurBackgroundDefaut=Color.lightGray;
  Color couleurExtraLumiere=Color.white;
  Color couleurLumiere=new Color(223, 223, 223);
  Color couleurOmbre=new Color(127, 127, 127);
  Color couleurExtraOmbre=Color.black;
  Color couleurTexteSurligne=Color.blue;
  Color couleurTexteNormal=Color.black;
  Color couleurTexteGrise=couleurOmbre;

  //avec combien on monte l'onglet si c'est selectionne
  static final int remonteSel=2;

  //deplacement Horizontal et Vertical pour les coins arrondis
  static final int arrondiHor=2;
  static final int arrondiVer=2;

  //o'u on commence a ecrire la chaine
  static final int XTitre=4;
  static final int YTitre=2;

  //hauteur de l'image des onglets
  int Z;

  //la largeur de la ligne qu'on utilise pour dessiner
  int largLigne;

  //longueur et hauteur totale des onglets et du cadre
  int X=400;
  int Y=400;

  //l'information sur chaque onglet :nom,debut,fin (en pixels), couleurs, actives
  //donc, un max de 25 onglets=largement suffisant
  final int nbMax=25;
  Panel tabPanel[]=new Panel[nbMax];
  String tabNom[]=new String[nbMax];
  int tabFin[]=new int[nbMax];
  int tabDeb[]=new int[nbMax];
  Color tabCol[]=new Color[nbMax];
  boolean tabAct[]=new boolean[nbMax];

  //le nombre total des onglets ajoutes
  int nbOng=0;
  //quel onglet a ete choisi
  int choisi=0;
  //quel onglet a ete surligne
  int surligne=-1;

  public String toString() {
    return (new String("VasOnglets v3.0, 24 janvier 1999, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }

  //X,Y : longueur, hauteur totale des onglets(avec les panels)
  //posX,posY : le coin haut gauche des Onglets a l'interieur de l'applet
  public VasOnglets(int posX, int posY, int X, int Y) {
    this(posX, posY, X, Y, 2);
  }//fin constructeur

  //X,Y : longueur, hauteur totale des onglets(avec les panels)
  //posX,posY : le coin haut gauche des Onglets a l'interieur de l'applet
  //largeur de la bordure des onglets
  public VasOnglets(int posX, int posY, int X, int Y, int largeurBordure) {
    this.X=X;
    this.Y=Y;
    this.reshape(posX, posY, X, Y);
    this.setBackground(couleurBackgroundDefaut);
    this.setLayout(null);
    largLigne=largeurBordure;
    Z=carPoliceG.getHeight()+2*largLigne+2*YTitre+1;
  }//fin constructeur

  //Ajout d'un onglet avec le nom donne
  public void ajouteOnglet(String nom, Panel p) {
    if(nbOng>=tabDeb.length || p==this) return;
    tabNom[nbOng]=nom;
    tabDeb[nbOng]=(nbOng==0) ? 0 : ((nbOng==1) ? tabFin[nbOng-1]-largLigne : tabFin[nbOng-1]);
    tabFin[nbOng]=(nbOng==0) ? 2*XTitre+carPoliceG.stringWidth(nom)+4*largLigne : tabDeb[nbOng]+2*XTitre+carPoliceG.stringWidth(nom)+2*largLigne;
    tabCol[nbOng]=couleurBackgroundDefaut;
    tabAct[nbOng]=true;
//security
  if(nbOng>=maxAuthorized) tabAct[nbOng]=false;
//end_security
    //on ne peut pas rajouter 2 fois le meme Panel ou avec le meme nom
    for(int i=0; i<nbOng; i++) if(tabPanel[i]==p || tabNom[i].equals(nom)) return;
    //on ne peut pas ajouter plus d'onglets que la largeur du Panel
    if(tabFin[nbOng]>X) return;
    p.reshape(largLigne, Z+1, X-2*largLigne, Y-Z-largLigne-1);
    this.add(p);
    //seulement le premier onglet sera affiche au debut
    if(nbOng!=choisi) p.hide();
    tabPanel[nbOng]=p;
    nbOng++;
  }//fin ajouteOnglet

  //vous DEVEZ appeler cette fonction apres l'appel de
  //ajouteOnglet, supprimeOnglet, metCouleurOnglet, activeOnglet, desactiveOnglet, renommeOnglet et selectOnglet
  //dans des conditions "dynamiques", cad pas dans le constructeur ou init
  //rafraichit les onglets, cad redessine tout
  public void rafraichitOnglets() {
    paint(getGraphics());
  }//fin rafraichitOnglets

  //suppression d'un onglet
  public void supprimeOnglet(String nom) {
    //on cherche l'onglet que l'on veut supprimer
    for(int i=0; i<nbOng; i++) {
      if(tabNom[i].equals(nom)) {
        this.remove(tabPanel[i]);
        selectOnglet(tabNom[0]);
        int longOng=tabFin[i]-tabDeb[i];
        //recalcul de la taille des onglets
        for(int j=i; j<nbOng-1; j++) {
          if(j==0) {
            tabFin[j]+=largLigne;
            tabDeb[j]+=largLigne;
          }//fin if
          else {
            tabFin[j]=tabFin[j+1]-longOng;
            tabDeb[j]=tabDeb[j+1]-longOng;
          }//fin else
          tabNom[j]=tabNom[j+1];
          tabCol[j]=tabCol[j+1];
          tabAct[j]=tabAct[j+1];
          tabPanel[j]=tabPanel[j+1];
        }//fin for
        nbOng--;
        return;
      }//end if
    }//end for
  }//fin supprimeOnglet

  //met la couleur dans l'onglet donne
  public void metCouleurOnglet(String nom, Color col) {
    //on cherche l'onglet
    for(int i=0; i<nbOng; i++) {
      if(tabNom[i].equals(nom)) {
        tabCol[i]=col;
        return;
      }//fin if
    }//fin for
  }//fin metCouleurOnglet

  //desactive l'onglet specifie
  public void desactiveOnglet(String nom) {
    //on cherche l'onglet
    for(int i=0; i<nbOng; i++) {
      if(tabNom[i].equals(nom)) {
        tabAct[i]=false;
        return;
      }//fin if
    }//fin for
  }//fin desactiveOnglet

  //active l'onglet specifie
  public void activeOnglet(String nom) {
    //on cherche l'onglet
    for(int i=0; i<nbOng; i++) {
      if(tabNom[i].equals(nom)) {
//security
  if(i>=maxAuthorized) return;
//end_security
        tabAct[i]=true;
        return;
      }//fin if
    }//fin for
  }//fin activeOnglet

  //pour renommer un onglet
  public void renommeOnglet(String avant, String apres) {
    //on cherche l'onglet que l'on veut renommer
    for(int i=0; i<nbOng; i++) {
      if(tabNom[i].equals(avant)) {
        int diff=carPoliceG.stringWidth(apres)-carPoliceG.stringWidth(avant);
        //si le dernier ne depasse pas le cadre
        if((tabFin[nbOng-1])+diff>X) return;
        tabNom[i]=new String(apres);
        tabFin[i]+=diff;
        //recalcul de la taille des onglets
        for(int j=i+1; j<nbOng; j++) {
          tabFin[j]+=diff;
          tabDeb[j]+=diff;
        }//fin for
        break;
      }//fin if
    }//fin for
  }//fin renommeOnglet

  //pour selectionner et afficher un onglet donne
  public void selectOnglet(String nom) {
    //on cherche l'onglet
    for(int i=0; i<nbOng; i++) {
      if(tabNom[i].equals(nom)) {
        if(i==choisi || !tabAct[i]) return;
        //restauration de la taille de l'onglet choisi precedement
        tabDeb[choisi]+=largLigne;
        tabFin[choisi]-=largLigne;
        tabPanel[choisi].hide();
        //on selectionne et on affiche l'onglet choisi
        choisi=i;
        tabPanel[choisi].show();
        //elargissement de l'onglet choisi courrament
        tabDeb[i]-=largLigne;
        tabFin[i]+=largLigne;
        return;
      }//fin if
    }//fin for
  }//fin selectOnglet

  //dessine l'onglet numero cour
  private void dessineOnglet(int cour){
    if(cour<0 || cour>=nbOng) return;
    Graphics g=getGraphics();
    //pour le choisi, c'est special
    int pasChoisi=(cour==choisi) ? 0 : 1;
    g.setFont((cour==choisi) ? policeGOnglet : policeOnglet);

    //pour mettre la couleur pour cet onglet
    g.setColor(tabCol[cour]);
    if(cour==choisi) g.fillRect(tabDeb[cour]+largLigne, largLigne+pasChoisi*remonteSel, tabFin[cour]-tabDeb[cour]-2*largLigne, Z);
    else g.fillRect(tabDeb[cour]+largLigne, largLigne+pasChoisi*remonteSel, tabFin[cour]-tabDeb[cour]-2*largLigne, Z-(2*largLigne+pasChoisi*remonteSel)+1);

    g.setColor(couleurOmbre);
    for(int i=largLigne; cour!=(choisi-1) && i>0; i--) {
      if(i==1) g.setColor(couleurExtraOmbre);
      //dessine la ligne droite de l'onglet
      g.drawLine(tabFin[cour]-i, pasChoisi*remonteSel+arrondiVer+largLigne-i-1, tabFin[cour]-i, Z-largLigne+i-i*pasChoisi);
      //l'arrondi droit de l'onglet=point sur la diagonale
      if(i==1) g.drawLine(tabFin[cour]-largLigne, pasChoisi*remonteSel+1, tabFin[cour]-1, pasChoisi*remonteSel+largLigne);
    }//fin for

    //on ecrit la chaine
    if(tabAct[cour]) {
      if(cour==surligne) g.setColor(couleurTexteSurligne);
      else g.setColor(couleurTexteNormal);
    }//end if
    else g.setColor(couleurTexteGrise);
    g.drawString(tabNom[cour], tabDeb[cour]+largLigne*(2-pasChoisi)+XTitre, pasChoisi*remonteSel+YTitre+largLigne+carPoliceG.getAscent());

    g.setColor(couleurExtraLumiere);
    for(int i=0; i<largLigne; i++) {
      if(i==1) g.setColor(couleurLumiere);
      int dernier=(i==largLigne-1 && i!=0) ? -1 : 0;
      //dessine la ligne du haut de l'onglet
      g.drawLine(tabDeb[cour]+arrondiHor+i+dernier, pasChoisi*remonteSel+i, tabFin[cour]-largLigne-arrondiHor+1, pasChoisi*remonteSel+i);
      if(cour!=(choisi+1)) {
        //dessine la ligne gauche de l'onglet
        g.drawLine(tabDeb[cour]+i, pasChoisi*remonteSel+arrondiVer, tabDeb[cour]+i, Z-largLigne+i-i*pasChoisi);
        //l'arrondi gauche de l'onglet=un point sur la diagonale
        if(i==0) g.drawLine(tabDeb[cour]+1, pasChoisi*remonteSel+1, tabDeb[cour]+1, pasChoisi*remonteSel+1);
      }//fin if
    }//fin for
  }//fin dessineOnglet

  //dessine les onglets et le contour
  public void paint(Graphics g){
    //on met tout a zero
    g.setColor(couleurBackgroundDefaut);
    g.fillRect(0, 0, X, Z+1);

    //un par un on dessine les onglets
    for(int cour=0; cour<nbOng; cour++) {
      dessineOnglet(cour);
    }//fin for

    //on fait le grand contour
    g.setColor(couleurExtraLumiere);
    for(int i=0; i<largLigne; i++) {
      if(i==1) g.setColor(couleurLumiere);
      //dessine la ligne du bas des onglets (haut du contour)
      //1 :jusqu'a l'onglet courant
      if(choisi!=0) g.drawLine(i, Z-largLigne+i+1, tabDeb[choisi]+i, Z-largLigne+i+1);
      //2 :apres l'onglet courant
      g.drawLine(tabFin[choisi]-i, Z-largLigne+i+1, X, Z-largLigne+i+1);
      //dessine la ligne de gauche du contour
      g.drawLine(i, Z-(largLigne-i-1), i, Y);
    }//fin for
    g.setColor(couleurOmbre);
    for(int i=largLigne; i>0; i--) {
      if(i==1) g.setColor(couleurExtraOmbre);
      //dessine la ligne du bas du contour
      g.drawLine(i-1, Y-i, X, Y-i);
      //dessine la ligne droite du contour
      g.drawLine(X-i, Z-(largLigne-i), X-i, Y);
    }//fin for
  }//fin paint

  //on determine quand un onlet a ete selectionne
  public boolean mouseDown(Event event, int x, int y) {
    //calcule sur quel onglet different on a clique
    if(y<Z) {
      for(int i=0; i<nbOng; i++) {
        if(x>tabDeb[i] && x<tabFin[i] && i!=choisi && tabAct[i]) {
          selectOnglet(tabNom[i]);
          //on redessine tout
          rafraichitOnglets();
          return true;
        }//fin if
      }//fin for
    }//fin if
    return false;
  }//fin mouseDown

  //on determine quand un onlet doit etre surligne
  public boolean mouseMove(Event event, int x, int y) {
    int avant=surligne;
    //calcule sur quel onglet different la souris est passee
    if(y<Z) {
      for(int i=0; i<nbOng; i++) {
        if(x<tabFin[i] && x>tabDeb[i]) {
          //rien a faire si on est deja dans le bon onglet
          if(i==surligne) return true;
          if(!tabAct[i]) {
            //redessine les onglets si la souris passe au-dessus d'un onglet desactive
            //rien n'est surligne
            //ne redessine pas quand on passe d'un onglet desactive
            //a un autre onglet desactive
            if(avant!=nbOng) {
              surligne=nbOng;
              dessineOnglet(avant);
            }//fin if
            return true;
          }//fin if
          surligne=i;
          //on redessine les deux onglets en question
          dessineOnglet(avant);
          dessineOnglet(surligne);
          return true;
        }//fin if
      }//fin for
    }//fin if
    else {
      //redessine les onglets si la souris passe au-dessus d'un onglet desactive
      //rien n'est surligne
      if(avant!=nbOng) {
        surligne=nbOng;
        dessineOnglet(avant);
      }//fin if
    }//fin else
    return false;
  }//fin mouseDown

  //pour determiner quand la souris est sortie du composant
  public boolean mouseExit(Event event, int x, int y) {
    int avant=surligne;
    //redessine les onglets si la souris passe au-dessus d'un onglet desactive
    //rien n'est surligne
    if(avant!=nbOng) {
      surligne=nbOng;
      dessineOnglet(avant);
    }//fin if
    return true;
  }//fin mouseExit
}//fin classe Onglets
